//+------------------------------------------------------------------+
//|                                          VininI_StatusMarket.mq4 |
//|                                Copyright  2008, Victor Nicolaev |
//|                                                    vinin@mail,ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "vinin@mail,ru"

//        .
//  ,     :   .
//    -       


#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 Green
#property indicator_maximum  1
#property indicator_minimum -1
#property indicator_level1 -0.5
#property indicator_level2  0 
#property indicator_level3  0.5

//---- input parameters
extern int       TimeFrame=10080;
extern int Limit=1440;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

int CountBar;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexDrawBegin(0,TimeFrame);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexDrawBegin(1,TimeFrame);
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexDrawBegin(2,TimeFrame);
   
   if (TimeFrame<Period()) TimeFrame=Period();
   CountBar=TimeFrame/Period();
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int    counted_bars=IndicatorCounted();
   int    limit=Bars-counted_bars;
   if (limit>Limit && Limit>0) limit=Limit;
   for (int i=limit;i>0;i--) {
      ExtMapBuffer1[i]=ExtMapBuffer1[i+1];
      ExtMapBuffer2[i]=ExtMapBuffer2[i+1];
      ExtMapBuffer3[i]=ExtMapBuffer3[i+1];
      if (i+CountBar<Bars) {
         double Body=Close[i]-Open[i+CountBar];
         double Shadow_up=High[iHighest(NULL,0,MODE_HIGH,CountBar,i)]-MathMax(Close[i],Open[i+CountBar]);
         double Shadow_dn=MathMin(Close[i],Open[i+CountBar])-Low[ iLowest( NULL,0,MODE_LOW, CountBar,i)];
         double aBody=MathAbs(Body);
  
         if (aBody+Shadow_up+Shadow_dn!=0)   ExtMapBuffer1[i]=Body/(aBody+Shadow_up+Shadow_dn);
         if (aBody+Shadow_up!=0)             ExtMapBuffer2[i]=Body/(aBody+Shadow_up);
         if (aBody+Shadow_dn!=0)             ExtMapBuffer3[i]=Body/(aBody+Shadow_dn);
      }
   }
   return(0);
}

